(define makeTriples
  (lambda (n1 n2)  ; (how_many_triples, range)
    (letrec
      ((mkrndtriple
         (lambda ()
          `(,(random n2) ,(random n2) ,(random n2))))
       (mktriples
         (lambda (n1 lst)
           (cond
             ((eq? n1 0) lst)
             (else
               (mktriples (- n1 1) (cons (mkrndtriple) lst)))))))
    (mktriples n1 '()))))


(define makeCmp
  (lambda (s1 s2 r c1 s3 c2) ; (selector, selector, reduce, comparator, selector, comparator)
    (lambda (t1 t2)
      (if (= (r (s1 t1) (s2 t1)) (r (s1 t2) (s2 t2)))   ; check for equality wrt primary criterion
            (c2 (s3 t1) (s3 t2))                             ; use the secondary sorting criterion
            (c1 (r (s1 t1) (s2 t1)) (r (s1 t2) (s2 t2))))))) ; use the primary sorting criterion

(define triples (makeTriples 12 10))
triples
(newline)

(sort triples (makeCmp car   cadr  +   < car   <))   ; 1
(sort triples (makeCmp car   cadr  +   > car   >))   ; 2
(sort triples (makeCmp car   caddr +   < car   <))   ; 3
(sort triples (makeCmp cadr  caddr max < car   <))   ; 4
(sort triples (makeCmp cadr  caddr max > car   >))   ; 5
(sort triples (makeCmp car   cadr  min < caddr <))   ; 6
(sort triples (makeCmp car   car   max < cadr  <))   ; 7
(sort triples (makeCmp caddr caddr max > car   >))   ; 8
(sort triples (makeCmp car   car   max < cadr  >))   ; 9
(sort triples (makeCmp car   cadr  *   < caddr <))   ; 10

;1  ascending order on sum of the first two elements, use first element as a tie breaker
;2 descending order on sum of the first two elements, use first element as a tie breaker
;3  ascending order on sum of the first and third elements, use first element as a tie breaker
;4  ascending order on maximum of the second and third elements, use first element as a tie breaker
;5 descending order on maximum of the second and third elements, use first element as a tie breaker
;6  ascending order on minimum of the first and second elements, use third element as a tie breaker
;7  ascending order on first element, use second element as a tie breaker
;8 descending order on third element, use first element as a tie breaker
;9  ascending order on first element, use second element, in descending order, as a tie breaker
;10 ascending order on product of the first two elements, use third element as a tie breaker
